﻿
Global PluginName$ = "Plugin #1"
Global PluginVersion$ = "1.1"
Global PluginDesc$ = "Test Plugin #1"

XIncludeFile "..\shared.pbi"

;===================================================================================================
; Выполняет необходимые действия при загрузке плагина.
; Эта функция не обязательна.
;===================================================================================================
ProcedureDLL PluginInit()
  ;     MessageRequester(PluginName$, "Загружен")
EndProcedure

;===================================================================================================
; Выполняет необходимые действия перед выгрузкой плагина.
; Эта функция не обязательна.
;===================================================================================================
ProcedureDLL PluginFinal()
  ;   MessageRequester(PluginName$, "Выгружен")
EndProcedure

;===================================================================================================
; Возвращает строку в формате JSON, содержащую информацию о плагине.
; Эта функция ОБЯЗАТЕЛЬНА.
;===================================================================================================
ProcedureDLL.s GetPluginInfo()
  Define plug.PluginInfo, res$

  plug\Version = PluginVersion$
  plug\Name = PluginName$
  plug\Description = PluginDesc$
  
  ; Здесь для всех функций, которые необходимо вызывать через меню, добавляются пары ключ/значение:
  ; "Имя_функции_с_учетом_регистра": "Название_пункта_меню_для_вызова_функции"
  AddMapElement(plug\Functions(), "Test1")
  plug\Functions() = "Call function Test1"
  
  AddMapElement(plug\Functions(), "Test2")
  plug\Functions() = "Call function Test2"
  
  If CreateJSON(0)
    InsertJSONStructure(JSONValue(0), @plug, PluginInfo)
    res$ = ComposeJSON(0)
    FreeJSON(0)
  EndIf
  
  ProcedureReturn res$
EndProcedure

;===================================================================================================

ProcedureDLL.l Test1(Param1.l, Param2.l = 0, Param3.l = 0, Param4.l = 0)
  MessageRequester(PluginName$, "Testing1 ... " + Str(Param1 + Param2 + Param3 + Param4))
EndProcedure

ProcedureDLL.l Test2(Param1.l, Param2.l = 0, Param3.l = 0, Param4.l = 0)
  MessageRequester(PluginName$, "Testing1 ... " + Str(Param1) + " " + PeekS(Param2))
EndProcedure

; IDE Options = PureBasic 5.51 (Windows - x86)
; ExecutableFormat = Shared dll
; CursorPosition = 11
; Folding = -
; EnableXP
; Executable = ..\..\Plugins\test1.dll